<?PHP
// IT DISPLAYS THE TOTAL NUMBER OF RESOURCES , STUDENTS ENROLLED,
//EDITING/NON EDITING TEACHERS FOR THE COURSE SELECTED

require_once("../../config.php");
require_login();

################################
# url
################################
# Coloco esto así, pero después habría que 
# tomarlo directo del config.php pero no se como hacerlo hoy
$sitio=$CFG->wwwroot;
$urlcat=$sitio."/course/category.php?id=";
$urlcurso=$sitio."/course/view.php?id=";
$urlestcat=$sitio."/estadisticas/content/result_categories.php?catid=";
$urlestcurso=$sitio."/estadisticas/content/result_courses.php?courseid=";

global $USER;

$adminContext = get_context_instance(CONTEXT_SYSTEM, SITEID);
if(!user_has_role_assignment($USER->id,1,$adminContext->id)){
	redirect("block.php");
	exit();
}

#CHECK URL ID
$iCourseID = optional_param('courseid',0,PARAM_INT);
$iCatID = optional_param('catid',-1,PARAM_INT);

if($iCourseID<1 && $iCatID<1){
	redirect("../index.php");
	exit();
}
?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//ES" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>Estadísticas de Moodle</title>
<body>

<link rel="stylesheet" type="text/css" href="../styles/default.css" media="screen" />
<link rel="stylesheet" type="text/css" href="../styles/print.css" media="print" />
</head>

<body>
<p> <div style="text-align: center;"><img src="../images/moodle.png" alt="logo" /></div> </p>
<div id="search">
</p><span class="title">Estadísticas Moodle - curso</span></p>
</div>

<?php
//FUNCTIONS/////////////////////////////////////////////////////////////
function lastAccess($timestamp){
	if(date("d F Y - G:i",$timestamp)>date("d F Y - G:i",0)){
		$diff = time()-$timestamp;
		$days = $diff/(60 * 60 * 24);
		if($days>1){
			$days = ceil($days);
		}else{
			$days = 0;
		}
	}else{
		$days = -1;
	}

	return $days;
}

# Consulto id de curso
$courses = get_records_sql('SELECT id FROM mdl_course WHERE id='.$iCourseID);

foreach($courses as $c){

	$iCourseID = $c->id;

	//MAIN QUERIES
	$context = get_context_instance(CONTEXT_COURSE, $iCourseID);
	$oCourseResult = get_record_select('course','id='.$iCourseID,'id,fullname,timecreated,timemodified,category');
	//Obtengo el nombre de la categoría
	$oCatResult = get_record_select('course_categories','id='.$oCourseResult->category,'name');
	$aoTeacherDetailsResult = get_role_users(3, $context);
	$aoNonEditTeacherDetailsResult = get_role_users(4, $context);
	$aoStudentDetailsResult = get_role_users(5, $context);


	//ACTIVITY QUERIES
	$iAssignmentCount = count_records_select('assignment','course='.$iCourseID);
	$iChatCount = count_records_select('chat','course='.$iCourseID);
	$iChoiceCount = count_records_select('choice','course='.$iCourseID);
	$iForumCount = count_records_select('forum','course='.$iCourseID);
	$iGlossaryCount = count_records_select('glossary','course='.$iCourseID);
	$iHotPotCount = count_records_select('hotpot','course='.$iCourseID);
	$iQuestionCount = count_records_select('questionnaire','course='.$iCourseID);
	$iQuizCount = count_records_select('quiz','course='.$iCourseID);
	$iWikiCount = count_records_select('wiki','course='.$iCourseID);

	//LAST ACCESS FUNCTIONALITY
	$rsLastAccessDetailsResult = get_records_sql("SELECT mdl_user.id,mdl_user_lastaccess.timeaccess FROM mdl_user LEFT JOIN mdl_user_lastaccess ON 
		mdl_user.id=mdl_user_lastaccess.userid WHERE mdl_user_lastaccess.courseid = ".$iCourseID.";");
	$aLastAccess = array();
	foreach($rsLastAccessDetailsResult as $record){
		$aLastAccess[$record->id]=$record->timeaccess;
	}

	//STUDENT DETAILS - OUTPUT
	$iStudentLast10Days = 0;
	$iStudentNever = 0;
	$sStudentOutputString = '';
	$sStudentOutputString .='<p>';
	$sStudentOutputString .= '<span class="title">Detalles del estudiante: </span><br />';
	if(empty($aoStudentDetailsResult)){
		$sStudentOutputString .= "Ninguno matriculado";
	}else{
		$sStudentOutputString .= '<table>';
		$sStudentOutputString .= '<tr><th scope="col">Nombre Completo:</th><th scope="col">Usuario:</th><th scope="col">Último acceso a la plataforma:</th></tr>';
		$iLoop = 0;
		foreach($aoStudentDetailsResult as $record){
			if($iLoop%2<1){
				$sHighlight = "odd";
			}else{
				$sHighlight = "even";
			}
			$sStudentOutputString .= '<tr><td class="'.$sHighlight.'">'.$record->lastname.', '.$record->firstname.'</td><td class="'
				.$sHighlight.'">'.$record->username.'</td><td class="'.$sHighlight.'">';
			if(empty($aLastAccess[$record->id])){
				$sStudentOutputString .= 'Nunca';
				$iStudentNever++;
			}else{
				if(lastAccess($aLastAccess[$record->id])>0){
					$sStudentOutputString .=  lastAccess($aLastAccess[$record->id]).' Día(s) atrás';
					if(lastAccess($aLastAccess[$record->id])<11){
						$iStudentLast10Days++;
					}
				}else{
					$sStudentOutputString .=  'Hoy';
					$iStudentLast10Days++;
				}
			}
			$sStudentOutputString .= '</td></tr>';
			$iLoop++;
		}
		$sStudentOutputString .= '</table>';
	}
	$sStudentOutputString .= '</p>';
	
	//////////
	//OUTPUT//
	//////////
	//COURSE DETAILS
	echo '<p>';
	echo '<span class="title">Información general: </span><br />';
	echo '<table>';
	echo '<tr><td class="dark"><span class="bold">Reporte generado:</span></td><td class="odd">'.date("d F Y - G:i").'</td></tr>';
	echo '<tr><td class="dark"><span class="bold">Nombre:</span></td><td class="odd">'.$oCourseResult->fullname.
		'&nbsp;<a href="'.$urlcurso.$oCourseResult->id.'" target="_blank">[en EVA]</a></td></tr>';
	echo '<tr><td class="dark"><span class="bold">Fecha de creación:</span></td><td class="odd">'.date("d F Y - G:i",$oCourseResult->timecreated).'</td></tr>';
	echo '<tr><td class="dark"><span class="bold">Categoría "padre":</span></td>
                <td class="odd"><a href="'.$urlestcat.$oCourseResult->category.'">'.
                $oCatResult->name.'</a></td></tr>';
	echo '</table>';
	echo '</p>';
	echo '<hr />';

	//USAGE NUMBERS
	echo '<p>';
	echo '<span class="title">Resumen del curso: </span><br />';
	echo '<table>';
	echo '<tr><td><img src="../images/users.gif" alt="icon" /></td><td class="even">Número de estudiantes matriculados: </td><td class="even"><span class="title">&nbsp;';
	if(empty($aoStudentDetailsResult)){
		echo '0';
	}else{
		echo count($aoStudentDetailsResult);
	}
	echo '&nbsp;</span></td></tr>';

	/*
	echo '<tr><td><img src="../images/accessed.gif" alt="icon" /></td><td class="odd">Número de estudiantes que accedieron en los últimos 10 días: </td><td class="odd"><span class="title">&nbsp;'.$iStudentLast10Days.'&nbsp;</span></td></tr>';
	echo '<tr><td><img src="../images/never.gif" alt="icon" /></td><td class="even">Número de estudiantes que nunca acedieron al curso: </td><td class="even"><span class="title">&nbsp;'.$iStudentNever.'&nbsp;</span></td></tr>';
	*/

	echo '<tr><td><img src="../images/assignment.gif" alt="icon" /></td><td class="odd">Número de asignaciones de actividades:</td><td class="odd"><span class="title">&nbsp;'.$iAssignmentCount.'&nbsp;</span></td></tr>';
	echo '<tr><td><img src="../images/chat.gif" alt="icon" /></td><td class="even">Número de Chats utilizados:</td><td class="even"><span class="title">&nbsp;'.$iChatCount.'&nbsp;</span></td></tr>';
	echo '<tr><td><img src="../images/choice.gif" alt="icon" /></td><td class="odd">Número de Consultas utilizadas:</td><td class="odd"><span class="title">&nbsp;'.$iChoiceCount.'&nbsp;</span></td></tr>';
	echo '<tr><td><img src="../images/forum.gif" alt="icon" /></td><td class="even">Número de Foros utilizados:</td><td class="even"><span class="title">&nbsp;'.$iForumCount.'&nbsp;</span></td></tr>';
	echo '<tr><td><img src="../images/glossary.gif" alt="icon" /></td><td class="odd">Número de Glosarios utilizados:</td><td class="odd"><span class="title">&nbsp;'.$iGlossaryCount.'&nbsp;</span></td></tr>';
	echo '<tr><td><img src="../images/hotpot.gif" alt="icon" /></td><td class="even">Número de Hot Potatoes utilizados::</td><td class="even"><span class="title">&nbsp;'.$iHotPotCount.'&nbsp;</span></td></tr>';
	echo '<tr><td><img src="../images/quiz.gif" alt="icon" /></td><td class="even">Número de Cuestionarios utilizados:</td><td class="even"><span class="title">&nbsp;'.$iQuizCount.'&nbsp;</span></td></tr>';
	echo '<tr><td><img src="../images/wiki.gif" alt="icon" /></td><td class="odd">Número de Wikis utilizados:</td><td class="odd"><span class="title">&nbsp;'.$iWikiCount.'&nbsp;</span></td></tr>';
	echo '</table>';
	echo '</p>';
	echo '<hr />';

	//TEACHER DETAILS
	echo '<p>';
	echo '<span class="title">Detalles de profesor/a(s): </span><br />';
	if(empty($aoTeacherDetailsResult)){
		echo "Ninguno asignado";
	}else{
		echo '<table>';
		echo '<tr><th scope="col">Nombre completo:</th><th scope="col">Usuario:</th>';
		// borrado ultimo acceso pq no anda - <th scope="col">Último acceso a la plataforma:</th></tr>';
		echo '</tr>';
		$iLoop = 0;
		foreach($aoTeacherDetailsResult as $record){
			if($iLoop%2<1){
				$sHighlight = "odd";
			}else{
				$sHighlight = "even";
			}
			echo '<tr><td class="'.$sHighlight.'">'.$record->lastname.', '.$record->firstname.'</td><td class="'.$sHighlight.'">'.$record->username.'</td>';
			/* borrado last acess ----------
			<td class="'.$sHighlight.'">';
			if(empty($aLastAccess[$record->id])){
				echo 'Nunca';
			}else{
			if(lastAccess($aLastAccess[$record->id])>0){
				echo lastAccess($aLastAccess[$record->id]).' Días atrás';
			}else{
				echo 'Hoy';
			}
			}	
			echo '</td>';
			---------------------------------- */
			$iLoop++;
		}	
	echo '</table>';
	}
	echo '</p>';
	echo '<hr />';

	//NON-EDITING TEACHER DETAILS
	echo '<p>';
	echo '<span class="title">Detalles de profesor/a(s) sin permiso de edición: </span><br />';
	if(empty($aoNonEditTeacherDetailsResult)){
		echo "Ninguno asignado";
	}else{
		echo '<table>';
		echo '<tr><th scope="col">Nombre completo:</th><th scope="col">Usuario:</th>';

		// borrado ultimo acceso pq no anda - <th scope="col">Último acceso a la plataforma:</th></tr>';
		echo '</tr>';
		$iLoop = 0;
		foreach($aoNonEditTeacherDetailsResult as $record){
			if($iLoop%2<1){
				$sHighlight = "odd";
			}else{
				$sHighlight = "even";
			}
			echo '<tr><td class="'.$sHighlight.'">'.$record->lastname.', '.$record->firstname.'</td><td class="'.$sHighlight.'">'.$record->username.'</td>';

			/* borrado last acess ----------
			td class="'.$sHighlight.'">';
			if(empty($aLastAccess[$record->id])){
				echo 'Nunca';
			}else{
				if(lastAccess($aLastAccess[$record->id])>0){
				echo lastAccess($aLastAccess[$record->id]).' Días atrás';
				}else{
			echo 'Hoy';
			}
			}
			echo '</td>';
			---------------------------------- */

			$iLoop++;
		}
		echo '</table>';
	}
	echo '</p>';
}

echo '</p>';

?>

<hr />
<a href="javascript:print();">Imprimir</a><span class="noprint"> | Volver al</span><a href="../index.php">&nbsp;inicio</a>
</body>
</html>
